unit minedoutkonsoleview;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, minedoutbase, Crt;

type

  { TView }

  TView = class
  private
    FSpielerPosition : TPos;
    procedure UserAktionMelden(Taste : Char);
  public
    UserAktion : TAktionUser;
    constructor Create;
    destructor Destroy; override;
    function ZeichneSpielfeld(const DasSpielfeld : TSpielfeldArray) : Boolean;
    procedure SpielerBewegen (const NeuePos : TPos);
    procedure AufUsereingabenWarten;
  end;

implementation

{ TView }


procedure TView.UserAktionMelden(Taste: Char);
var
  DieAktion : TAktionen;
begin
  DieAktion:=TAktionen.uaNichtsTun;
  Case Ord(Taste) of
    72: DieAktion := TAktionen.uaNorden; // Nach Oben
    80: DieAktion := TAktionen.uaSueden; // Nach Unten
    75: DieAktion := TAktionen.uaWesten; // Nach Links
    77: DieAktion := TAktionen.uaOsten;  // Nach Rechts
    27: DieAktion := TAktionen.uaAbbrechen;
  end;
  if DieAktion <> TAktionen.uaNichtsTun then
    if Assigned(UserAktion) then
      UserAktion(DieAktion);
end;

constructor TView.Create;
begin

end;

destructor TView.Destroy;
begin
  inherited Destroy;
end;

function TView.ZeichneSpielfeld(const DasSpielfeld: TSpielfeldArray): Boolean;
var
  i, j : Integer;
  Inhalt : String;
begin
  Inhalt:='';
  for i := NORDRAND DownTo SUEDRAND do
    begin
      begin
        for j := WESTRAND to OSTRAND do
        begin
          case DasSpielfeld[j, i] of
          TFeldinhalt.Mine: Inhalt:=MINEN_SYMBOL;
          TFeldinhalt.Spieler: Inhalt:=SPIELER_SYMBOL;
          TFeldinhalt.Leer: Inhalt:=LEER_SYMBOL;
          TFeldinhalt.Ziel: Inhalt:=ZIEL_SYMBOl;
        otherwise
          Inhalt:='?';
        end;
        Write(Inhalt);
        end;
      end;
      Writeln;
    end;
  Result := True;
end;

procedure TView.SpielerBewegen(const NeuePos: TPos);
begin
  GotoXY(FSpielerPosition.X, FSpielerPosition.Y);
  Write(LEER_SYMBOL);
  FSpielerPosition := NeuePos;
  GotoXY(FSpielerPosition.X, FSpielerPosition.Y);
  Write(SPIELER_SYMBOL);
end;

procedure TView.AufUsereingabenWarten;
var
  Taste : Char;
begin
  while True do
    begin
      Taste:=ReadKey; // Die #0 abfangen
      UserAktionMelden(ReadKey);

    end;
end;

end.

