unit minedoutspiel;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,minedoutbase, minedoutspielfeld, minedoutkonsoleview,
  TesteSpielfeld;

type

  { TSpiel }

  TSpiel = class
    private
      FSpielfeld : TSpielfeld;
      FView : TView;
      procedure BewegungAusgefuehrt(const NeuePos : TPos);
      procedure VerarbeiteUserAktion(const DieAktion : TAktionen);
    public
      constructor Create;
      destructor Destroy; override;
      procedure Starten;

  end;

implementation


procedure TSpiel.BewegungAusgefuehrt(const NeuePos: TPos);
begin
  Case FSpielfeld.getInhalt(NeuePos) of
    TFeldinhalt.Mine: (* Spiel verloren *);
    TFeldinhalt.Ziel: (* Nächster Level oder Spiel gewonnen *);
  end;
end;

procedure TSpiel.VerarbeiteUserAktion(const DieAktion: TAktionen);
begin
  if DieAktion = TAktionen.uaAbbrechen then
    (* Spiel beenden *)
    Exit;
end;

constructor TSpiel.Create;
begin
  FSpielfeld := TSpielfeld.Create;
  FView := TView.Create;
  (* Events mit den Handlern verbinden *)
  FSpielfeld.BeiSpielerBewegung := @FView.SpielerBewegen;
  FSpielfeld.BeiSpielerBewegung := @self.BewegungAusgefuehrt;
  FView.UserAktion := @FSpielfeld.VerarbeiteUserAktion;
  FView.UserAktion := @self.VerarbeiteUserAktion;

end;

destructor TSpiel.Destroy;
begin
  FSpielfeld.Free;
  FView.Free;
  inherited Destroy;
end;

procedure TSpiel.Starten;
begin
  FView.ZeichneSpielfeld(FSpielfeld.getAlleInhalte);
  FView.AufUsereingabenWarten;
end;

end.



